Unit DE54R_p;
interface
uses
SysUtils, Math, { Delphi }
Lstruct, Lfunc, DE54RU_p, UTDE12_p;

procedure DE54R(FF :Func_F_DE; FG :Func_F_DE; FR :Func_F_DE; XN :Real;
                XK :Real; var CN :Array of Real;
                var CK :Array of Real; NX :Integer; X0 :Real;
                HX :Real; BULDY :Boolean; HMIN :Real;
                EPS :Real; P :Real; var H :Real;
                var Y :Array of Real; var DY :Array of Real;
                var NX1 :Integer; var IERR :Integer);

implementation

procedure DE54R(FF :Func_F_DE; FG :Func_F_DE; FR :Func_F_DE; XN :Real;
                XK :Real; var CN :Array of Real;
                var CK :Array of Real; NX :Integer; X0 :Real;
                HX :Real; BULDY :Boolean; HMIN :Real;
                EPS :Real; P :Real; var H :Real;
                var Y :Array of Real; var DY :Array of Real;
                var NX1 :Integer; var IERR :Integer);
var
I,IER1,NX1P1,J :Integer;
XN1,XK1,R :Real;
BUL1 :Boolean;
RA :Array [0..11] of Real;
TETUV :Array [0..2] of Real;
label
_1,_2,_3,_4,_5,_6,_8,_10,_11,_12,_13,_14,_15,_16;
begin
IERR := 0;
R := CN[0]*CN[0]+CN[1]*CN[1];
if ( R = 0.0 ) 
 then goto _10;
TETUV[1] := CN[2]/Sqrt(R);
if ( CK[1]*CK[1]+CK[0]*CK[0] = 0.0 ) 
 then goto _11;
TETUV[0] := ArcTan2(CN[1],CN[0]);
if ( (X0-XK)*(X0-XN) > 0.0 ) 
 then goto _12;
H := Sign(H,XK-XN);
R := Sign(1.0,XK-XN);
BUL1 := False;
XN1 := XN;
XK1 := X0;
for I:=1 to NX do
 begin
  if ( (XK-XK1)*R ) < 0
   then goto _1
   else if ( (XK-XK1)*R ) > 0
         then goto _3
         else goto _2;
_1:
  IERR := 1;
  XK1 := XK;
_2:
  NX1 := I;
  BUL1 := True;
  if ( I = NX ) 
   then goto _3;
  IERR := IERR+2;
_3:
  DE54RU(FF,FG,FR,2,XN1,TETUV,XK1,HMIN,EPS,P,H,TETUV,RA,IER1);
  if ( IER1 = 65 ) 
   then goto _13;
  Y[I-1] := TETUV[0];
  DY[I-1] := TETUV[1];
  if ( BUL1 ) 
   then goto _5;
  XN1 := XK1;
  XK1 := XK1+HX;
_4:
 end;
NX1 := NX;
DE54RU(FF,FG,FR,2,XN1,TETUV,XK,HMIN,EPS,P,H,TETUV,RA,IER1);
if ( IER1 = 65 ) 
 then goto _13;
_5:
XK1 := Cos(TETUV[1-1]);
R := Sin(TETUV[1-1]);
RA[0] := CK[0]*R-CK[1]*XK1;
if ( RA[0] = 0.0 ) 
 then goto _14;
TETUV[2] := (TETUV[1]*(CK[0]*XK1+CK[1]*R)-CK[2])/RA[0];
NX1P1 := NX1+1;
J := 1;
if ( not BUL1 ) 
 then goto _6;
IER1 := NX1;
J := 2;
XK1 := Sin(Y[IER1-1]);
R := Cos(Y[IER1-1]);
Y[IER1-1] := DY[IER1-1]*XK1+TETUV[2]*R;
if ( BULDY ) 
 then DY[IER1-1] := DY[IER1-1]*R-TETUV[2]*XK1;
_6:
XK1 := XK;
BUL1 := False;
for I:=J to NX1 do
 begin
  DE54RU(FF,FG,FR,3,XK1,TETUV,XN1,HMIN,EPS,P,H,TETUV,RA,IER1);
  if ( IER1 = 65 ) 
   then goto _15;
  IER1 := NX1P1-I;
  TETUV[0] := Y[IER1-1];
  TETUV[1] := DY[IER1-1];
  XK1 := Sin(Y[IER1-1]);
  R := Cos(Y[IER1-1]);
  Y[IER1-1] := DY[IER1-1]*XK1+TETUV[2]*R;
  if ( BULDY ) 
   then DY[IER1-1] := DY[IER1-1]*R-TETUV[2]*XK1;
  if ( BUL1 ) 
   then goto _6;
  XK1 := XN1;
  XN1 := XN1-HX;
_8:
 end;
goto _16;
_10:
IERR := 65;
goto _16;
_11:
IERR := 66;
goto _16;
_12:
IERR := 67;
goto _16;
_13:
IERR := 68;
goto _16;
_14:
IERR := 69;
goto _16;
_15:
IERR := 70;
_16:
if ( IERR <> 0 ) 
 then UTDE12(IERR,54);
end;

end.
